{{
SpinStruct Queue
A queue (FIFO) implemented here ussing a singly linked List.
Supports enqueue, dequeue, and size methods.
C++ STL supports push/pop methods which is VERY confusing.
They are aliases here if you have to have them.
}}

OBJ list: "slist" ' singly linked list 
VAR long qsize

PUB init
{{ init queue }}
  list.init
  qsize := 0

PUB enqueue(data)
{{ add data to queue end }}
  list.addItem(data)
  qsize++
  
PUB dequeue
{{ get data from queue front }}
  if qsize > 0
    result := list.getItem(list.top)
    list.deleteItem(list.top)
    qsize--
  
PUB size | p
{{ get queue size }}
  result := 0
  p := list.top
  repeat while(p)
    result++
    p := list.getNext(p)

PUB push(data)
{{ add data to queue end }}
  enqueue(data)
  
PUB pop
{{ get data from queue front }}
  return dequeue
